/* various 'utility' macros*/

// is vvv=<0,0,0> ?
#macro vzero_p(vvv)
	(vvv.x=0 & vvv.y=0 & vvv.z=0)
#end

// return a string representation of vector vvv
#macro vstring(vvv)
	concat("<",str(vvv.x,5,5),", ",str(vvv.y,5,5),", ",str(vvv.z,5,5),">") 
#end

//check for degenerate triangle
#macro degenerate_triangle_p(v1,v2,v3)
	vzero_p( vcross(v1-v2,v2-v3))
#end

// a check for 'degenerate' normals
#macro degenerate_norms_p(v1,v2,v3,n1,n2,n3)
        #local tnorm=vcross(v1-v2,v1-v3);
        #if(vzero_p(tnorm))
           #local ret=0;
        #else
           #local n1t=vdot(n1,tnorm);
           #local n2t=vdot(n2,tnorm);
           #local n3t=vdot(n3,tnorm);
           #if( n1t=0 | n2t=0 | n3t=0 )
		#local ret=0;
           #else
          	#local n1s=n1t/abs(n1t);
               	#local n2s=n2t/abs(n2t);
                #local n3s=n3t/abs(n3t);
               	#local ret=(abs(n1s+n2s+n3s)<2.5);
           #end
        #end
        ret
#end
// return vector normal to the triangle v1,v2,v3
#macro tnormal(v1,v2,v3)
        vnormalize(vcross(v2-v1,v3-v1))
#end


#ifndef(RedFreq)    #declare RedFreq=1;       #end
#ifndef(RedPhase)   #declare RedPhase=0;      #end
#ifndef(MinRed)     #declare MinRed=.4;       #end
#ifndef(MaxRed)     #declare MaxRed=1.0;      #end

#ifndef(GreenFreq)  #declare GreenFreq=1;     #end
#ifndef(GreenPhase) #declare GreenPhase=pi/2; #end
#ifndef(MinGreen)   #declare MinGreen=.4;     #end
#ifndef(MaxGreen)   #declare MaxGreen=1.0;    #end

#ifndef(BlueFreq)   #declare BlueFreq=1;      #end
#ifndef(BluePhase)  #declare BluePhase=pi;    #end
#ifndef(MinBlue)    #declare MinBlue=.4;      #end
#ifndef(MaxBlue)    #declare MaxBlue=1.0;     #end


#macro hcolor(beta)
  #local MidRed=(MaxRed-MinRed)/2;
  #local MidGreen=(MaxGreen-MinGreen)/2;
  #local MidBlue=(MaxBlue-MinBlue)/2;
  color
   < 
    MidRed*cos(RedFreq*beta+RedPhase)+MidRed+MinRed,
    MidGreen*cos(GreenFreq*beta+GreenPhase)+MidGreen+MinGreen,
    MidBlue*cos(BlueFreq*beta+BluePhase)+MidBlue+MinBlue
   > 
#end

#macro hfloat(beta,MinP,MaxP,PFreq,PPhase)
  #local MidP=(MaxP-MinP)/2;
  MidP*cos(PFreq*beta+PPhase)+MidP+MinP
#end

